package application;
import database.*;
import model.*;
import view.*;

public class TestInMemModel {
	
	public static void main(String [] args)throws DataException
	{
		IUserModel model=new UserModel();
		IViewer viewer=new TextViewer();
		
		IDataDelegate dal=new TestDataDelegate();
		
		model.setDataDelegate(dal);
		model.initialize();
		
		viewer.setModel(model);
		
		//test best case scenario
		System.out.println("--------------------------");
		System.out.println("Test 1. Testing valid user login");
		System.out.println("--------------------------");
		if(model.authorizeUser("Bob", "p1") )
		{
			viewer.displayUser();
		}
		else
		{
			viewer.displayError("Invalid user name or password");
		}
		System.out.println();
		
		//test invalid user name
		System.out.println("--------------------------");
		System.out.println("Test 2. Testing invalid user name");
		System.out.println("--------------------------");
		if(model.authorizeUser("Bobby", "p1") )
		{
			viewer.displayUser();
		}
		else
		{
			viewer.displayError("Invalid user name or password");
		}
		System.out.println();
		
		//test invalid password
		System.out.println("--------------------------");
		System.out.println("Test 3. Testing invalid password");
		System.out.println("--------------------------");
		if(model.authorizeUser("Bob", "p2") )
		{
			viewer.displayUser();
		}
		else
		{
			viewer.displayError("Invalid user name or password");
		}
		System.out.println();
	}

}
