package application;

import model.*;
import view.*;
import database.*;


public class TestModelWithTextView {
	public static void main(String [] args)
	{
		IUserModel model=new UserModel();
		IViewer viewer=new TextViewer();
		
		IDataDelegate dal=new FileDataDelegate("registered.txt","users.txt",",");
		
		model.setDataDelegate(dal);
		try
		{
			model.initialize();
		}catch(DataException de){
			System.out.println(de.getMessage());
			return;
		}
		
		viewer.setModel(model);
		
		if(model.authorizeUser("Bob", "p1") )
		{
			viewer.displayUser();
		}
		else
		{
			viewer.displayError("Invalid user name or password");
		}		
	}
}
