package view;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import model.*;

public class UserGUIViewer extends JFrame implements IViewer{	
	IUserModel model;
	JTextField nameTextField;
	JTextField scoreTextField;
	
	public void setModel(IUserModel model)
	{
		
		this.model=model;	
		
	}
	
	public void createView()
	{
		this.setTitle("User viewer");
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setSize(new Dimension(200, 80));
		this.getContentPane().setLayout(new GridLayout(2, 2));
		
		JLabel label1=new JLabel("User name:");
		nameTextField=new JTextField("");
		nameTextField.setEditable(false);
		
		JLabel label2=new JLabel("Score:");
		scoreTextField=new JTextField("");
		scoreTextField.setEditable(false);
		
		this.getContentPane().add(label1);
		this.getContentPane().add(nameTextField);
		this.getContentPane().add(label2);
		this.getContentPane().add(scoreTextField);	
		this.setVisible(true);
	}
	
	public void displayUser(){
		nameTextField.setText(model.getCurrent().getName());
		scoreTextField.setText(String.valueOf(model.getCurrent().getScore()));
	}
	
	public void displayError(String error)
	{
		nameTextField.setText(error);
	}

}
