package application;

import model.*;

import view.*;

import database.*;

public class TestMultipleViewsPull {
	public static void main(String [] args)
	{
		IUserModel model=new UserModel();
		
		
		IDataDelegate dal=new FileDataDelegate("registered.txt","users.txt",",");
		
		model.setDataDelegate(dal);
		try
		{
			model.initialize();
		}catch(DataException de){
			System.out.println(de.getMessage());
			return;
		}
		
		IViewer viewer1=new UserGUIView();
		viewer1.setModel(model);
		
		viewer1.createView();
		
		IViewer viewer2=new UserGUIEdit();
		viewer2.setModel(model);
		
		viewer2.createView();
		
		IViewer viewer3=new UserGUIEdit();
		viewer3.setModel(model);
		
		viewer3.createView();
		
		if(model.authorizeUser("Bob", "p1") )
		{
			viewer1.displayUser();
			viewer2.displayUser();
			viewer3.displayUser();
		}
		else
		{
			viewer1.displayError("Invalid user name or password");
			viewer2.displayError("Invalid user name or password");
			viewer3.displayError("Invalid user name or password");
		}
		
	}

}
