package model;

import database.*;

public class UserModel implements IUserModel {

	IDataDelegate dal;
	java.util.Map<String,User> usersMap;
	
	User currentUser;
	
	public void setDataDelegate(IDataDelegate dal)
	{
		this.dal=dal;
	}
	
	public void initialize() throws DataException
	{
		//reading authorize from the database - can throw exception
		usersMap=dal.load();		
	}
	
	public void saveAllChanges() throws DataException
	{
		dal.save(usersMap);
	}
	
	public boolean authorizeUser(String name, String pwd) 
	{
		try
		{
			if(dal.login(name,pwd))
			{
				currentUser=usersMap.get(name);
				return true;
			}
		}catch(DataException de){
			System.out.println(de.getMessage());			
		}
		return false;	
	}
	
	public User getCurrent()
	{		
		return currentUser;
	}	
	
	public void updateCurrent(String oldName, User user)
	{	
		if(usersMap.containsKey(oldName))
		{
			usersMap.remove(oldName);
		}
		usersMap.put(user.getName(), user);
		currentUser=user;
	}
	
	public void add(User user)
	{
		usersMap.put(user.getName(), user);
	}
	
	public void remove(String name)
	{
		usersMap.remove(name);
	}
}
