package application;

import model.*;

import view.*;

import database.*;

public class TestObserverPush {
	public static void main(String [] args)
	{
		UserModel model=new UserModel();
		
		
		IDataDelegate dal=new FileDataDelegate("registered.txt","users.txt",",");
		
		model.setDataDelegate(dal);
		try
		{
			model.initialize();
		}catch(DataException de){
			System.out.println(de.getMessage());
			return;
		}
		
		UserGUIView viewer1=new UserGUIView();
		viewer1.setModel(model);
		
		viewer1.createView();
		
		UserGUIEdit viewer2=new UserGUIEdit();
		viewer2.setModel(model);
		
		viewer2.createView();
		
		UserGUIEdit viewer3=new UserGUIEdit();
		viewer3.setModel(model);
		
		viewer3.createView();
		
		model.addObserver(viewer1);
		model.addObserver(viewer2);
		model.addObserver(viewer3);
		
		if(model.authorizeUser("Bob", "p1") )
		{
			viewer1.displayUser();
			viewer2.displayUser();
			viewer3.displayUser();
		}
		else
		{
			viewer1.displayError("Invalid user name or password");
			viewer2.displayError("Invalid user name or password");
			viewer3.displayError("Invalid user name or password");
		}
		
	}

}
