package view;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;


import model.*;

public class UserGUIEdit extends JFrame implements IViewer, ActionListener, IObserver{	
	IUserModel model;
	JTextField nameTextField;
	JTextField scoreTextField;
	
	JButton saveButton;
	JButton incrementScoreButton;	
	
	public void setModel(IUserModel model)	
	{
		this.model=model;
	}	
	
	public void createView()
	{
		this.setTitle("User editor");
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.setSize(new Dimension(200, 120));
		
		this.getContentPane().setLayout(new GridLayout(3, 2));
		
		JLabel label1=new JLabel("Name:");
		nameTextField=new JTextField("");		
		
		JLabel label2=new JLabel("Score:");
		scoreTextField=new JTextField("");
		
		incrementScoreButton=new JButton(">>");
		incrementScoreButton.addActionListener(this);
		saveButton=new JButton("Save");
		saveButton.addActionListener(this);		
		
		this.getContentPane().add(label1);
		this.getContentPane().add(nameTextField);
		this.getContentPane().add(label2);
		this.getContentPane().add(scoreTextField);
		this.getContentPane().add(incrementScoreButton);
		this.getContentPane().add(saveButton);
		
		this.setVisible(true);
	}
	
	public void displayUser(){
		nameTextField.setText(model.getCurrent().getName());
		scoreTextField.setText(String.valueOf(model.getCurrent().getScore()));
	}

	public void actionPerformed (ActionEvent event)
	{
		if(event.getSource()==incrementScoreButton)
		{
			int prevScore=this.model.getCurrent().getScore();
			this.model.getCurrent().setScore(prevScore+1);			
		}
		else if (event.getSource()==saveButton)
		{
			String prevName=this.model.getCurrent().getName();
			User updatedUser=new User(nameTextField.getText());			
			
			try
			{
				int newScore=Integer.parseInt(scoreTextField.getText());
				updatedUser.setScore(newScore);
			}catch (NumberFormatException nfe) {updatedUser.setScore(this.model.getCurrent().getScore());}  //ignore invalid input
			
			this.model.updateCurrent(prevName, updatedUser);
			((IObservable)this.model).stateChanged();
		}
		
		displayUser();
	}
	
	public void displayError(String error)
	{
		nameTextField.setText(error);
	}
	
	public void updateView(IUserModel updatedModel)
	{
		this.model=updatedModel;
		displayUser();
	}
}
