package application;

import model.*;
import view.*;
import controller.*;
import database.*;


public class UserAppMVCMultipleViews {
	public static void main(String [] args)
	{
		UserModel model=new UserModel();		
		
		IDataDelegate dal=new FileDataDelegate("registered.txt","users.txt",",");
		
		model.setDataDelegate(dal);
		try
		{
			model.initialize();
		}catch(DataException de){
			System.out.println(de.getMessage());
			return;
		}
		
		UserLoginController loginController=new UserLoginController();
		
		GeneralUserGUI loginViewer = new GeneralUserGUI();
		
		
		loginViewer.setController(loginController);
		
		loginController.setModel(model);
		loginController.setViewer(loginViewer);
		
		
		loginViewer.createView();
		loginController.updateViewer();
		
		UserEditController editController=new UserEditController();
		GeneralUserGUI editViewer = new GeneralUserGUI();
	
		
		editViewer.setController(editController);
		
		editController.setModel(model);
		editController.setViewer(editViewer);
		
		
		editViewer.createView();
		editController.updateViewer();
		
		
		model.addObserver(loginViewer);	
		model.addObserver(editViewer);
		
	}
}
