package controller;

import javax.swing.*;

import model.*;
import view.*;


public class UserEditController implements IController {
	
	IUserModel model;
	GeneralUserGUI viewer;	
	
	
	public void setViewer(GeneralUserGUI viewer)
	{
		this.viewer=viewer;
	}
	
	public void setModel(IUserModel model)
	{
		this.model=model;
	}
	
	public void updateModel()
	{
		String prevName=model.getCurrent().getName();
		String username=viewer.firstTextField.getText();
		String scoreString=viewer.secondTextField.getText();
		
		int score=this.model.getCurrent().getScore();
		try
		{
			score=Integer.parseInt(scoreString);
			
		}catch(NumberFormatException nfe){}
		
		User updatedUser=new User(username);
		updatedUser.setScore(score);
		
		this.model.updateCurrent(prevName, updatedUser);
		((IObservable)this.model).stateChanged();		
	}
	
	public void populateViewer()
	{
		//customize elements
		viewer.firstButton.setText(">>");
		viewer.firstButton.setEnabled(true);
		viewer.secondButton.setText("Save");
		
		viewer.firstLabel.setText("User name:");
		viewer.secondLabel.setText("Score:");
		
		//viewer.firstTextField.setText(this.model.getName());
		viewer.getContentPane().remove(viewer.secondTextField);		
		
		viewer.secondTextField=new JTextField();
		viewer.getContentPane().add(viewer.secondTextField, 3);
		
		viewer.setTitle("User edit");
	}
	
	public void updateViewer()
	{		
		if(this.model.getCurrent()!=null)
		{
			viewer.firstTextField.setText(model.getCurrent().getName());
			viewer.secondTextField.setText(""+model.getCurrent().getScore());
		}
		
	}	
	

	public void performFirstAction()
	{
		int prevScore=this.model.getCurrent().getScore();
		
		//try to read prevScore from secondTextField
		try
		{
			String strScore=viewer.secondTextField.getText();
			prevScore=Integer.parseInt(strScore);
		}catch(NumberFormatException nfe){}
		
		viewer.secondTextField.setText(String.valueOf(prevScore+1));
	}  
	
	public void performSecondAction()
	{
		updateModel();
		
	}
	
	
}