package controller;
import model.*;

import view.*;
import database.*;

import javax.swing.*;
import java.awt.*;

public class UserLoginController implements IController {
	
	IUserModel model;
	GeneralUserGUI viewer;
	
	
	public void setViewer(GeneralUserGUI viewer)
	{
		this.viewer=viewer;
	}
	
	public void setModel(IUserModel model)
	{
		this.model=model;
	}
	
	public void updateModel()
	{
		String username=viewer.firstTextField.getText();
		String password=viewer.secondTextField.getText();		
		
		if (model.authorizeUser(username, password))
		{
			IController editController=new UserEditController();
			editController.setModel(this.model);
			editController.setViewer(this.viewer);
			viewer.setController(editController);
			//viewer.setVisible(false);
			editController.populateViewer();		
			
			((IObservable)this.model).stateChanged();		
		}
		else
		{
			viewer.firstTextField.setText("Invalid user name or pwd");			
		}			
	}
	
	public void populateViewer()
	{
		//customize elements
		viewer.firstButton.setText("");
		viewer.firstButton.setEnabled(false);
		viewer.secondButton.setText("Login");
		
		viewer.firstLabel.setText("User name:");
		viewer.secondLabel.setText("Password:");
		
		viewer.getContentPane().remove(viewer.secondTextField);		
		
		viewer.secondTextField=new JPasswordField();
		viewer.getContentPane().add(viewer.secondTextField, 3);
		
		viewer.setTitle("User login")	;
	}
	
	public void updateViewer()
	{
		
	}	
	
	public void performFirstAction(){}  //does not do anything, the button is disabled 
	
	public void performSecondAction()
	{
		updateModel();		
	}	
	
}
