package view;
import javax.swing.*;


import java.awt.*;
import java.awt.event.*;


import model.*;
import controller.*;

public class GeneralUserGUI extends JFrame implements IViewer, ActionListener, IObserver{	
	
	IController controller;
	
	public JTextField firstTextField;
	public JTextField secondTextField;
	
	public JButton firstButton;
	public JButton secondButton;	
	
	public JLabel firstLabel;
	public JLabel secondLabel;
	
		
	public void setController(IController controller)
	{
		this.controller=controller;		
	}
	

	public void createView()
	{
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.setSize(new Dimension(200, 120));
		this.getContentPane().setLayout(new GridLayout(3, 2));
		firstLabel=new JLabel("First:");
		firstTextField=new JTextField("");
		
		
		secondLabel=new JLabel("Second:");
		secondTextField=new  JTextField("");
		
		firstButton=new JButton("First action");
		firstButton.addActionListener(this);
		secondButton=new JButton("Second action");
		secondButton.addActionListener(this);	
		
		this.getContentPane().add(firstLabel);
		this.getContentPane().add(firstTextField);
		this.getContentPane().add(secondLabel);
		this.getContentPane().add(secondTextField);
		this.getContentPane().add(firstButton);
		this.getContentPane().add(secondButton);
		
		controller.populateViewer();
		
		this.setVisible(true);
	}		
	
		
	public void actionPerformed (ActionEvent event)
	{
		if(event.getSource()==firstButton)
		{
			this.controller.performFirstAction();
		}
		else if (event.getSource()==secondButton)
		{
			this.controller.performSecondAction();
		}		
	}
	
	public void updateView(IUserModel updatedModel)
	{
		controller.setModel(updatedModel);
		controller.updateViewer();
		
	}	
	
}

